unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, PaxCompiler, StdCtrls, PaxProgram, PaxBasicLanguage;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    PaxCompiler1: TPaxCompiler;
    PaxProgram1: TPaxProgram;
    PaxBasicLanguage1: TPaxBasicLanguage;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  I: Integer;
  t: Integer;
begin
  PaxCompiler1.Reset;
  PaxCompiler1.RegisterLanguage(PaxBasicLanguage1);

  PaxCompiler1.RegisterHeader(0, 'function IntToStr(Value: Integer): string;', @IntToStr);
  PaxCompiler1.RegisterHeader(0, 'function StrToInt(const S: string): Integer;', @StrToInt);

  PaxCompiler1.AddModule('1', PaxBasicLanguage1.LanguageName);

  PaxCompiler1.AddCode('1', 'Dim I As Integer, K As Integer');
  PaxCompiler1.AddCode('1', 'For I=1 to 200000');
  PaxCompiler1.AddCode('1', '  K = StrToInt(IntToStr(I))');
  PaxCompiler1.AddCode('1', 'Next');

  if PaxCompiler1.Compile(PaxProgram1) then
  begin
    t := GetTickCount;
    PaxProgram1.Run;
    ShowMessage(IntToStr(GetTickCount - t));
  end
  else
    for I:=0 to PaxCompiler1.ErrorCount - 1 do
      ShowMessage(PaxCompiler1.ErrorMessage[I]);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  I, K, t: Integer;
begin
  t := GetTickCount;
  for I:=1 to 200000 do
    K := StrToInt(IntToStr(I));
  ShowMessage(IntToStr(GetTickCount - t));
end;

end.
